/*  Original project started 01/11/94 at 7:54PM by Tom Grandgent  */
/*  Last worked on 04/18/94  */
/*  Work continues on 08/25/94 */
/*  Last worked on 08/25/94  */
/*  Work continues on 11/24/94 */
/*  Last worked on 11/29/94  */
/*  Work continues on 12/28/94 */
/*  Last worked on 01/22/95  */

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include "tommud.h"

#define q_size 25    	      	/* Max # of message in the queue */
#define NPC_MOVE_CHANCE	10	/* The NPC has a one in x chance of moving */

	int q_waiting = 0;		/* Messages waiting */
	int q_next = 0;			/* Next message location */
	char msgqueue[q_size][80];	/* Message queue data space */
	char prompt[40];		/* Current prompt string */

void qprintf(char *qstring) {
	if (q_next < q_size) {
		strcpy(msgqueue[q_next], qstring);
		q_next++;
		q_waiting++;
		}
	}

void qrelease(void) {
	int a;

	for (a = 0; a < q_waiting; a++)	printf("%s", msgqueue[a]);
	q_next = 0;
	q_waiting = 0;
	}

	void heartbeat(void);
	void battletick(void);

	/* GLOBAL VARIABLES */

	typedef enum {FALSE, TRUE} LOGICAL;
	char response[60];	/* Input string from user       */
	char lastrep[60];	/* Last input string from user	*/
	char bpos[18][25];	/* Strings for body positions	*/
	int heartcount = 0;	/* Number of heartbeats		*/
	unsigned long onetime;  /* Helps calling the heartbeat  */
	unsigned long tmptime;
	int maxobj;		/* Max number of objects	*/
	int filenpc;		/* Number of NPCs in NPC.DAT    */
	int maxnpc = 20;	/* Number of NPCs in memory  	*/
	int way[200 + 1][7];	/* Room exit destinations array */
	int totalrooms;		/* Total actual rooms read in	*/
	int inv[45];		/* Inventory array              */
	int invbk[65];		/* Used in sorting inventory    */
	int equipinv[20];	/* Equipment inventory array	*/
	int setcolor = 1;	/* Is color on (1) or off (0)?  */
	int sc = 0;		/* Synonym counting variable    */
	int soundfx = 1;	/* Heartbeat sound true/false	*/
	unsigned long starttime;/* Seconds at start of game 	*/
	void showprompt(void);	/* Displays the prompt		*/
	void input(void);	/* FUNC: My GETS equiv.		*/
	void cls(void);		/* FUNC: Clearscreen using DOS  */
	void locate(int, int);	/* FUNC: Position cursor	*/
	void color(int color);  /* FUNC: Sets an ANSI color	*/
	int number_range(int, int);	/* FUNC: Random number from x to x */
	int dice(int hitroll, int damroll); /* FUNC: Does a dice roll */

void main(int argc, char *argv[])
	{					/* main */

	/* LOCAL VARIABLES */

	FILE *fp;
	char item[20];		/* Item name string (from response) */
	char tmpch[70];		/* Temporary string for misc.	*/
	char yn;
	int i, xa, xb, xc;	/* Misc. counter variables      */
	long int a = 0;
	int b = 0, c = 0, k;
	int brief = 0;		/* Brevity / verbosity flag     */
	int nodbl = 0;		/* Fixes warp double-prompt bug */
//	int gt = 4;		/* # of letters in get or take  */
//	int nosee = 0;		/* Used to determine if obj is  */
				/* not in current room          */
	void roomdesc(int);	/* FUNC: Displays room descs    */
	void showobj(void);	/* FUNC: Displays objects       */
	void shownpc(void);	/* FUNC: Displays NPCs		*/
	int take(void);		/* FUNC: Takes item(s)          */
	int drop(void);		/* FUNC: Drops item(s)          */
	int kill(void);		/* FUNC: Attack an NPC!		*/
	int donate(void);	/* FUNC: Donates item(s)        */
	int wield(void);	/* FUNC: Wields item(s)		*/
	int hold(void);		/* FUNC: Holds item		*/
	int wear(void);		/* FUNC: Wears item(s)		*/
	int rem(void);		/* FUNC: Removes item(s)	*/
	int recite(void);	/* FUNC: Recites scroll		*/
	int score(void);	/* FUNC: Displays score		*/
	void help(void);	/* FUNC: Displays help  	*/
	void countrooms(void);	/* FUNC: Counts the rooms	*/
	void longhelp(void);	/* FUNC: Specific help		*/
	void color(int);	/* FUNC: Sets colors with ANSI  */
	void initways(void);	/* FUNC: Initialize exits array */
	void initobj(void);	/* FUNC: Initialize objects	*/
	void initnpc(void);	/* FUNC: Initialize NPCs	*/
	void loadplayer(void);	/* FUNC: Loads player data	*/
	int saveplayer(void);	/* FUNC: Saves player data	*/
	void inventory(int);	/* FUNC: Shows an inventory (0) */
	void equ(void);		/* FUNC: Shows equipment used	*/
	void info(void);	/* FUNC: Shows system info	*/
	void nogo(void);	/* FUNC: Says "can't go this.." */
	int actions(void);	/* FUNC: Handles misc. actions  */
	int is_ansi_loaded(void); /* FUNC: Is ansi loaded?	*/

			/* Variable initialization */
	nosound();
	pl.bonus = 0;
	for (i = 0;  i < 40;  i++) {
		inv[i] = -1;
		invbk[i] = -1;
		}
	for (i = 0;  i < 20;  i++) {
		equipinv[i] = -1;
		}
			/* Misc. Preparation */
	srand(time(NULL));	    /* Initialize the random # generator */
	countrooms();		    /* Count the # of rooms in ROOM.DAT */
	if (is_ansi_loaded()) {	    /* If ANSI.SYS is loaded, 		*/
		setcolor = 1;	    /*  Set color defaulted to on.. 	*/
		}
	else {			    /*  Or, set color defaulted to off. */
		cls();
		printf("ANSI.SYS is not loaded!  Color is defaulting to off.\n\n");
		setcolor = 0;
		printf("Press a key to continue...");
		getch();
		}
							/* PROGRAM START */
			/* Display the intro screen */
	cls();
	color(1);
	printf(" --------------MiniMUD V. 2.0%c by Tom Grandgent, based on JediMUD-------------\n\n", 225);
	printf("This version has many, MANY improvements over the old releases of 1.0 I had\n");
	printf("been making.  Absolutely ALL data about the objects, rooms, and roomexit\n");
	printf("roomnumbers is now stored in files.  You can also wear, wield, and hold\n");
	printf("items now.  Brevity/verbosity has been installed.  The '!' repeat command\n");
	printf("has been installed.  If you don't know what I'm talking about, check out the\n");
	printf("new and much improved help system, which is also completely stored in a file.\n");
	printf("I have also created a room-browser program, which I hope to expand so it will\n");
	printf("have to ability of editing rooms, adding rooms, and deleting rooms.  Then\n");
	printf("someone who knows nothing about the programming structure could create their\n");
	printf("own MUD worlds.  Oh, and I also have yet to create a similar program to handle\n");
	printf("object-browsing.  <ramble ramble ramble> :)  Also there are now like, 22\n");
	printf("objects (mostly wearables).  Check out room #45!\n");
	printf("If you need help just type 'help'.\n\n");
	printf("Press enter to continue..");
	getch();
	cls();
	locate(11, 28);
	printf("Loading data files...");
	initobj(); 		    /* Initialize objects */
	initnpc();		    /* Initialize NPCs */
	initways();		    /* Initialize exit ways */
	loadplayer();		    /* Load player information */
	starttime = time(NULL);
	onetime = time(NULL) - starttime;
	cls();
Input:			/* Input routine */
	roomdesc(brief);
	shownpc();
	showobj();
NoDesc:
/*  -------------------- Maintenance Cycle ------------------ */
	if (q_waiting > 0) qrelease();
	if (pl.level < 30) {
		do	{
			if (pl.exp >= levexp[pl.level]) {
				printf("You rise a level!\n");
				pl.maxhit = pl.maxhit + number_range(7, 12);
				pl.level++;
				strcpy(pl.title, levtitle[pl.level]);
				}
			}
		while (pl.level < 30 && pl.exp > levexp[pl.level]);
		}
/*  --------------------------------------------------------- */
	printf("\n");
	showprompt();
NoPrompt:
	strcpy(lastrep, response);
/*	do {
	tmptime = time(NULL) - starttime;
	if (tmptime % 4 == 0 && tmptime > onetime) {
	b = (tmptime - onetime) / 4;
	onetime = tmptime;
	for (a = 0; a < b; a++)
		heartbeat();
	}
	if (q_waiting > 0) {
		printf("\n");
		qrelease();
		sprintf(prompt, "H %d> ",pl.hit);
		printf("\n%s",prompt);
		}
	} while (!kbhit()); */
	// gets(response);
	input();			// MAIN INPUT ROUTINE
	if (strlen(response) > 55)
		goto NoDesc;
	while (isspace(response[0])) {
		for (c = 0;  response[c] != '\0';  c++)
			response[c] = response[c + 1];
		}
NoAsk:
	if (strnicmp("\0", response, 1) == 0 && nodbl != 0) {
		nodbl = 0;
		goto NoPrompt;
		}
	if (strnicmp("exp", response, 3) == 0) {
		printf("How much experience do you want: ");
		scanf("%lu", &pl.exp);
		goto NoDesc;
		}
	if (strnicmp("sound", response, 5) == 0 || strnicmp("quiet", response, 5) == 0) {
		if (soundfx == 1) soundfx = 0; else soundfx = 1;
		goto NoDesc;
		}
	if (strnicmp("level", response, 5) == 0) {
		do	{
			printf("What level would you like to be on: ");
			scanf("%d", &pl.level);
			}
		while (pl.level < 1 || pl.level > 30);
		pl.exp = levexp[pl.level - 1];
		goto NoDesc;
		}
	if (strnicmp("info", response, 4) == 0) {
		info();
		goto NoDesc;
		}
	if (strnicmp("hit", response, 3) == 0) {
		printf("Give me a number to go up to: ");
		scanf("%d", &c);
		b = 0;
		a = 0;
		do	{
			b++;
			a = a + dice(pl.hitroll, pl.damroll) + pl.bonus;
			}
		while (b < c);
		printf("After %d hits the average hit value was %d.\n", b, a / b);
		goto NoDesc;
		}
	if (strnicmp("look", response, 4) == 0 || strnicmp("l\0", response, 2) == 0)
		goto Input;
	if (strnicmp("help", response, 4) == 0 && strlen(response) < 6) {
		help();
		goto NoDesc;
		}
	if (strnicmp("help", response, 4) == 0) {
		longhelp();
		goto NoDesc;
		}
	if (strnicmp("save", response, 4) == 0) {
		printf("Saving %s...\n", pl.name);
		saveplayer();
		goto NoDesc;
		}
	if (strnicmp("quit", response, 4) == 0 || strnicmp("exit", response, 4) == 0) {
		if (saveplayer() == 1) {
			printf("For some reason I can't open your player data file (PLAYER.DAT) for\n");
			printf("write access.  Do you still want to quit? (Y/N): ");
			yn = getch();
			if (tolower(yn) == 'n') goto NoDesc; else printf("\n");
			}
		color(3);
		exit(1);
		}
	if (strnicmp("!", response, 1) == 0) {
		strcpy(response, lastrep);
		goto NoAsk;
		}
	if (strnicmp("brief", response, 5) == 0 || strnicmp("verbose", response, 7) == 0) {
		if (brief == 0) {
			brief = 1;
			printf("Display is now brief.\n");
			}
		else {
			brief = 0;
			printf("Display is now verbose.\n");
			}
		goto NoDesc;
		}
	if (strnicmp("shell", response, 5) == 0) {
		color(3);
		system("command.com");
		while (fopen("room.dat", "r") == NULL) {
			printf("\nHey ding dong.  You're in the wrong directory.  Try going back to\n");
			printf("the directory that TOMMUD is in.  It's like %s.\n", argv[0]);
			printf("Just 'cause I'm nice, I'll give you another chance to fix things.");
			system("command.com");
			}
		printf("\n");
		color(1);
		goto Input;
		}
	if (strnicmp("color", response, 5) == 0) {
		if (setcolor == 1) {
			color(3);
			setcolor = 0;
			}
		else {
			setcolor = 1;
			color(1);
			}
		goto NoDesc;
		}
/*	if (strnicmp("emote", response, 5) == 0) {
		strcpy(tmpch, pl.name);
		b = strlen(pl.name) + 2;
		for (c = 7; response[c] != '\0'; c++) {
		tmpch[b] = response[c];
		b++;
		}
		printf("%s */
	if (strnicmp("hurt", response, 4) == 0) {
		printf("Ouch.\n");
		pl.hit-=10;
		goto NoDesc;
		}
	if (strnicmp("sit", response, 3) == 0) {
		if (pl.pos == 1) {
			printf("You're already sitting!\n");
			goto NoDesc;
			}
		if (pl.pos != 0) {
			printf("You can't sit when you're %s!\n", posdesc[pl.pos]);
			goto NoDesc;
			}
		printf("You are now sitting.\n");
		pl.pos = 1;
		goto NoDesc;
		}
	if (strnicmp("stand", response, 5) == 0) {
		if (pl.pos == 0) {
			printf("You're already standing!\n");
			goto NoDesc;
			}
		if (pl.pos != 1) {
			printf("You can't stand when you're %s!\n", posdesc[pl.pos]);
			goto NoDesc;
			}
		printf("You are now standing.\n");
		pl.pos = 0;
		goto NoDesc;
		}
	if (strnicmp("way", response, 3) == 0) {
		printf("Current room: %d  Way array: %d, %d, %d, %d, %d, %d\n", pl.curloc, way[pl.curloc][1], way[pl.curloc][2],
			way[pl.curloc][3], way[pl.curloc][4], way[pl.curloc][5], way[pl.curloc][6]);
		goto NoDesc;
		}
	if (strnicmp("warp", response, 4) == 0) {
		printf("Please enter a roomnumber from 1 to %d: ", totalrooms);
		scanf("%d", &xa);
		printf("\n");
		if (xa > 0 && xa < totalrooms + 1) {
			pl.curloc = xa;
			nodbl = 1;
			goto Input;
			}
		else {
			printf("That's an invalid roomnumber!\n");
			nodbl = 1;
			goto NoDesc;
			}
		}
	if (strnicmp("\0", response, 1) == 0)
		goto NoDesc;
	if (take() == 1)
		goto NoDesc;
	if (drop() == 1)
		goto NoDesc;
// KILL
		k = kill();
		if (k == 1) goto NoDesc;
		if (k == 2) goto Input;
// END KILL
	if (donate() == 1)
		goto NoDesc;
	if (wield() == 1)
		goto NoDesc;
	if (hold() == 1)
		goto NoDesc;
	if (wear() == 1)
		goto NoDesc;
	if (rem() == 1)
		goto NoDesc;
	if (score() == 1)
		goto NoDesc;
	switch (recite()) {
	case (1):
		goto NoDesc;
	case (2):
		goto Input;
		}
	if (strnicmp("i", response, 1) == 0 || strnicmp("inventory", response, 9) == 0) {
		inventory(0);
		goto NoDesc;
		}
	if (strnicmp("equ", response, 3) == 0) {
		equ();
		goto NoDesc;
		}
	if (actions() == 1)
		goto NoDesc;

	if (strnicmp("n\0", response, 2) == 0 || strnicmp("north", response, 5) == 0) {
		if (pl.pos != 0) {
			printf("You must be standing to move.\n");
			goto NoDesc;
			}
		if (pl.move < 1) {
			printf("You are too tired to move.\n");
			goto NoDesc;
			}
		if (way[pl.curloc][1] != 0 && way[pl.curloc][1] != 200) {
			pl.curloc = way[pl.curloc][1];
			if (pl.move > 0) pl.move--;
			goto Input;
			}
		else {
			nogo();
			goto NoDesc;
			}
		}
	if (strnicmp("s\0", response, 2) == 0 || strnicmp("south", response, 5) == 0) {
		if (pl.pos != 0) {
			printf("You must be standing to move.\n");
			goto NoDesc;
			}
		if (pl.move < 1) {
			printf("You are too tired to move.\n");
			goto NoDesc;
			}
		if (way[pl.curloc][2] != 0 && way[pl.curloc][2] != 200) {
			pl.curloc = way[pl.curloc][2];
			if (pl.move > 0) pl.move--;
			goto Input;
			}
		else {
			nogo();
			goto NoDesc;
			}
		}
	if (strnicmp("w\0", response, 2) == 0 || strnicmp("west", response, 4) == 0) {
		if (pl.pos != 0) {
			printf("You must be standing to move.\n");
			goto NoDesc;
			}
		if (pl.move < 1) {
			printf("You are too tired to move.\n");
			goto NoDesc;
			}
		if (way[pl.curloc][3] != 0 && way[pl.curloc][3] != 200) {
			pl.curloc = way[pl.curloc][3];
			if (pl.move > 0) pl.move--;
			goto Input;
			}
		else {
			nogo();
			goto NoDesc;
			}
		}
	if (strnicmp("e\0", response, 2) == 0 || strnicmp("east", response, 4) == 0) {
		if (pl.pos != 0) {
			printf("You must be standing to move.\n");
			goto NoDesc;
			}
		if (pl.move < 1) {
			printf("You are too tired to move.\n");
			goto NoDesc;
			}
		if (way[pl.curloc][4] != 0 && way[pl.curloc][4] != 200) {
			pl.curloc = way[pl.curloc][4];
			if (pl.move > 0) pl.move--;
			goto Input;
			}
		else {
			nogo();
			goto NoDesc;
			}
		}
	if (strnicmp("u\0", response, 2) == 0 || strnicmp("up", response, 2) == 0) {
		if (pl.pos != 0) {
			printf("You must be standing to move.\n");
			goto NoDesc;
			}
		if (pl.move < 1) {
			printf("You are too tired to move.\n");
			goto NoDesc;
			}
		if (way[pl.curloc][5] != 0 && way[pl.curloc][5] != 200) {
			pl.curloc = way[pl.curloc][5];
			if (pl.move > 0) pl.move--;
			goto Input;
			}
		else {
			nogo();
			goto NoDesc;
			}
		}
	if (strnicmp("d\0", response, 2) == 0 || strnicmp("down", response, 4) == 0) {
		if (pl.pos != 0) {
			printf("You must be standing to move.\n");
			goto NoDesc;
			}
		if (pl.move < 1) {
			printf("You are too tired to move.\n");
			goto NoDesc;
			}
		if (way[pl.curloc][6] != 0 && way[pl.curloc][6] != 200) {
			pl.curloc = way[pl.curloc][6];
			if (pl.move > 0) pl.move--;
			goto Input;
			}
		else {
			nogo();
			goto NoDesc;
			}
		}

	printf("What!?!\n");
	goto NoDesc;

	}					/* main */

int actions(void)
	{

	if (strnicmp("nw\0", response, 3) == 0 || strnicmp("ne\0", response, 3) == 0 || strnicmp("sw\0", response, 3) == 0 || strnicmp("se\0", response, 3) == 0) {
		printf("Sorry, that direction is not currently implemented.\n");
		return (1);
		}
	if (strnicmp("giggle", response, 6) == 0) {
		printf("You giggle.\n");
		return (1);
		}
	if (strnicmp("fart", response, 4) == 0) {
		printf("You let out a big one!  Where are your manners?\n");
		return (1);
		}
	if (strnicmp("cry", response, 3) == 0) {
		printf("You burst into tears.\n");
		return (1);
		}
	if (strnicmp("sob", response, 3) == 0) {
		printf("You sob quietly to yourself.\n");
		return (1);
		}
	if (strnicmp("beg", response, 3) == 0) {
		printf("You beg the gods for mercy. (You're never gonna get it!)\n");
		return (1);
		}
	if (strnicmp("laugh", response, 5) == 0) {
		printf("You split your sides laughing.\n");
		return (1);
		}
	if (strnicmp("grin", response, 4) == 0) {
		printf("You grin evilly.\n");
		return (1);
		}
	if (strnicmp("burp", response, 4) == 0) {
		printf("You burp loudly and forget to excuse yourself.\n");
		return (1);
		}
	if (strnicmp("meow", response, 4) == 0) {
		printf("You meow loudly and get hit in the head with a brick.  Ow.\n");
		return (1);
		}
	if (strnicmp("woof", response, 4) == 0) {
		printf("You bark like a dog- WOOF WOOF WOOF!!\n");
		return (1);
		}
	if (strnicmp("jump", response, 4) == 0) {
		printf("You jump up and down and the ground shakes a little.\n");
		return (1);
		}
	if (strnicmp("telnet", response, 6) == 0) {
		printf("Sorry bud, this isn't the Internet!\n");
		return (1);
		}
	if (strnicmp("smile", response, 5) == 0) {
		printf("You smile happily.\n");
		return (1);
		}
	if (strnicmp("puke", response, 4) == 0 || strnicmp("barf", response, 4) == 0) {
		printf("People stare in horror as you regurgitate all over the floor.\n");
		return (1);
		}
	if (strnicmp("moo\0", response, 4) == 0) {
		printf("You moo deeply like a cow and start to chew on some grass.\n");
		return (1);
		}
	return (0);
	}

void roomdesc(int brief)
	{					/* Room description routine */

	FILE *fproom;
	int a = 0, b = 0, c = 0;
	char show[81];

	if ((fproom = fopen("room.dat", "r")) == NULL) {
		printf("\n\aError, cannot open ROOM.DAT room description data file.\n\n");
		color(3);
		exit(1);
		}

	for (a = 0;  1 == 1;  a++) {
		fgets(show, 80, fproom);
		if (show[0] == '~' && c == 1)
			break;
		if (show[0] == '~')
			b++;
		if (show[0] != '~' && b == pl.curloc) {
			printf("%s", show);
			if (brief == 1)
				goto BriefBye;
			c = 1;
			}
		}
BriefBye:

	fclose(fproom);
	}


void nogo(void)
	{					/* nogo */
	printf("Alas, you cannot go that way...\n");
	}					/* nogo */

void initobj(void)
	{					/* initobj */

	FILE *fpobj;
	int a = 0;

	if ((fpobj = fopen("obj.dat", "r")) == NULL) {
		printf("\n\aError, cannot open OBJ.DAT object data file.\n\n");
		color(3);
		exit(1);
		}

	fscanf(fpobj, "TYPES OF OBJ'S: %d\n", &maxobj);

	for (a = 0;  a < maxobj + 1;  a++) {
		fscanf(fpobj, "%d,%d,%d,%d,%d,%d,%d,%d\n", &obj[a].curloc,
			&obj[a].ac, &obj[a].hitroll, &obj[a].damroll, &obj[a].food,
			&obj[a].water, &obj[a].magic, &obj[a].worn);
		obj[a].num = a;
		if (obj[a].curloc == 0) obj[a].curloc = number_range(1, totalrooms - 1);
		fgets(obj[a].title, 80, fpobj);
		fgets(obj[a].small, 40, fpobj);
		fgets(obj[a].syn[1], 30, fpobj);
		fgets(obj[a].syn[2], 30, fpobj);
		fgets(obj[a].syn[3], 30, fpobj);
		fgets(obj[a].syn[4], 30, fpobj);
		obj[a].title[strlen(obj[a].title) - 1] = '\0';
		obj[a].small[strlen(obj[a].small) - 1] = '\0';
		obj[a].syn[1][strlen(obj[a].syn[1]) - 1] = '\0';
		obj[a].syn[2][strlen(obj[a].syn[2]) - 1] = '\0';
		obj[a].syn[3][strlen(obj[a].syn[3]) - 1] = '\0';
		obj[a].syn[4][strlen(obj[a].syn[4]) - 1] = '\0';
		}

	fclose(fpobj);

	}					/* initobj */

void showobj()
	{					/* showobj */
	int a = 0;

	for (a = 0;  a < maxobj + 1;  a++) {
		if (obj[a].curloc == pl.curloc) {
			color(2);
			printf("%s\n", obj[a].title);
			color(1);
			}
		}

	}					/* showobj */

void shownpc(void)
	{					/* shownpc */
	int a = 0;

	for (a = 0;  a < maxnpc + 1;  a++) {
		if (npc[a].curloc == pl.curloc && npc[a].mobility == 0) {
			color(2);
			printf("%s\n", npc[a].title);
			color(1);
			}
		}

	for (a = 0;  a < maxnpc + 1;  a++) {
		if (npc[a].curloc == pl.curloc && npc[a].mobility != 0) {
			color(2);
			printf("%s\n", npc[a].title);
			color(1);
			}
		}
	}					/* shownpc */

void initnpc(void)
	{					/* initobj */

	FILE *fpnpc;
	int a = 0, b = 0, c = 0, d = 0;

	if ((fpnpc = fopen("npc.dat", "r")) == NULL) {
		printf("\n\aError, cannot open NPC.DAT object data file.\n\n");
		color(3);
		exit(1);
		}

	fscanf(fpnpc, "TYPES OF NPC'S: %d\n", &filenpc);
// EXPERIMENTAL START <READ MAXNPC FROM FILE TOTAL>
	for (b = 0;  b < filenpc; b++) {
	fscanf(fpnpc, "%d\n", &d);
	fgets(npc[0].title, 80, fpnpc);
	fgets(npc[0].title, 80, fpnpc);
	fgets(npc[0].title, 80, fpnpc);
	fgets(npc[0].title, 80, fpnpc);
	fgets(npc[0].title, 80, fpnpc);
	fgets(npc[0].title, 80, fpnpc);
	fgets(npc[0].title, 80, fpnpc);
	}
	fclose(fpnpc);
	if ((fpnpc = fopen("npc.dat", "r")) == NULL) {
		printf("\n\aError, cannot open NPC.DAT object data file.\n\n");
		color(3);
		exit(1);
		}
	fscanf(fpnpc, "TYPES OF NPC'S: %d\n", &filenpc);
	for (b = 0;  b < filenpc;  b++) {
	fscanf(fpnpc, "%d\n", &d);
	fscanf(fpnpc, "%d,%d,%d,%d,%d,%d,%d,%lu,%d,%d,%d,%d,%d,%d\n",
		&npc[MAXNPC].curloc, &npc[MAXNPC].mobility, &npc[MAXNPC].maxhit, &npc[MAXNPC].maxmana,
		&npc[MAXNPC].maxmove, &npc[MAXNPC].ac, &npc[MAXNPC].alignment,
		&npc[MAXNPC].exp, &npc[MAXNPC].gold, &npc[MAXNPC].level, &npc[MAXNPC].pos,
		&npc[MAXNPC].hitroll, &npc[MAXNPC].damroll, &npc[MAXNPC].bonus);
	npc[MAXNPC].hit = npc[MAXNPC].maxhit;
	npc[MAXNPC].mana = npc[MAXNPC].maxmana;
	npc[MAXNPC].move = npc[MAXNPC].maxmove;
	fgets(npc[MAXNPC].title, 80, fpnpc);
	fgets(npc[MAXNPC].small, 40, fpnpc);
	fgets(npc[MAXNPC].syn[1], 30, fpnpc);
	fgets(npc[MAXNPC].syn[2], 30, fpnpc);
	fgets(npc[MAXNPC].syn[3], 30, fpnpc);
	fgets(npc[MAXNPC].syn[4], 30, fpnpc);
	npc[MAXNPC].title[strlen(npc[MAXNPC].title) - 1] = '\0';
	npc[MAXNPC].small[strlen(npc[MAXNPC].small) - 1] = '\0';
	npc[MAXNPC].syn[1][strlen(npc[MAXNPC].syn[1]) - 1] = '\0';
	npc[MAXNPC].syn[2][strlen(npc[MAXNPC].syn[2]) - 1] = '\0';
	npc[MAXNPC].syn[3][strlen(npc[MAXNPC].syn[3]) - 1] = '\0';
	npc[MAXNPC].syn[4][strlen(npc[MAXNPC].syn[4]) - 1] = '\0';
	for (c = 0; c < d; c++) {
	npc[a].curloc = npc[MAXNPC].curloc;
	if (npc[a].curloc == 0) npc[a].curloc = number_range(1, totalrooms);
	npc[a].mobility = npc[MAXNPC].mobility;
	npc[a].maxhit = npc[MAXNPC].maxhit;
	npc[a].maxmana = npc[MAXNPC].maxmana;
	npc[a].maxmove = npc[MAXNPC].maxmove;
	npc[a].ac = npc[MAXNPC].ac;
	npc[a].alignment = npc[MAXNPC].alignment;
	npc[a].exp = npc[MAXNPC].exp;
	npc[a].gold = npc[MAXNPC].gold;
	npc[a].level = npc[MAXNPC].level;
	npc[a].pos = npc[MAXNPC].pos;
	npc[a].hitroll = npc[MAXNPC].hitroll;
	npc[a].damroll = npc[MAXNPC].damroll;
	npc[a].bonus = npc[MAXNPC].bonus;
	npc[a].hit = npc[a].maxhit;
	npc[a].mana = npc[a].maxmana;
	npc[a].move = npc[a].maxmove;
	strcpy(npc[a].title, npc[MAXNPC].title);
	strcpy(npc[a].small, npc[MAXNPC].small);
	strcpy(npc[a].syn[1], npc[MAXNPC].syn[1]);
	strcpy(npc[a].syn[2], npc[MAXNPC].syn[2]);
	strcpy(npc[a].syn[3], npc[MAXNPC].syn[3]);
	strcpy(npc[a].syn[4], npc[MAXNPC].syn[4]);
	a++;
	}
	}
	maxnpc = a - 1;
	fclose(fpnpc);
	}					/* initobj */

void color(int a)
	{					/* color */
	char esc = 27;

	if (setcolor == 1) {
		switch (a) {
		case (1):
			{
			printf("%c[36m", esc);
			break;
			}
		case (2):
			{
			printf("%c[32m", esc);
			break;
			}
		case (3):
			{
			printf("%c[0;37;40m", esc);
			break;
			}
			}
		}
	}					/* color */

void help(void)
	{					/* help */

	printf("HELP\n");
	printf(" For a quick summary screen type QUICK.  To display more\n");
	printf("detailed help, type HELP SUBJECT.\n\n");
	printf("Some help topics are:  !, COLOR, BRIEF, DONATE, DROP, EQUIPMENT, GET, HOLD,\n");
	printf("INVENTORY, LOOK, RECITE, REMOVE, ROOMNUM, SHELL, VERBOSE, WARP, WAYS, WEAR,\n");
	printf("WIELD\n");

	}					/* help */

void initways(void)
	{					/* initways */

	FILE *fpway;
	int a = 0, b = 0;

	if ((fpway = fopen("ways.dat", "r")) == NULL) {
		printf("\n\aError, cannot open WAYS.DAT exit data file.\n\n");
		color(3);
		exit(1);
		}

	for (a = 1;  a < totalrooms + 1;  a++) {
		for (b = 1;  b < 7;  b++) {
			fscanf(fpway, "%d,", &way[a][b]);
			}
		fscanf(fpway, "\n");
		}

	fclose(fpway);

	}					/* initways */

void inventory(int a)
	{					/* inventory */
	int xa = 0, b = 0;

	printf("You are carrying:\n");
	if (a == 1)
		for (xa = 0;  invbk[xa] != -1;  xa++)
			printf(" %s\n", obj[invbk[xa]].small);
	if (a != 1)
		for (xa = 0;  inv[xa] != -1;  xa++) {
			printf(" %s\n", obj[inv[xa]].small);
			b++;
			if (b > 21) {
				printf("--More--\n");
				b = 0;
				getch();
				}

			}
	if (inv[0] == -1)
		printf(" Nothing.\n");

	}					/* inventory */

int drop(void)
	{					/* drop */

	char item[20];			/* Item name string (from response) */
	int a = 0, i, xa, xb, xc;	/* Misc. counter variables          */
					/* not in current room              */

			/* ----------- DROP CODE ----------- */
	if (strnicmp("drop", response, 4) == 0) {
		if (strlen(response) < 6) {
			printf("Drop what?\n");
			return (1);
			}
		if (strnicmp("drop all", response, 8) == 0) {
			for (xc = 0;  xc < 40;  xc++) {
				if (inv[xc] != -1) {
					xb = inv[xc];
					inv[xc] = -1;
					printf("You drop %s.\n", obj[xb].small);
					obj[xb].curloc = pl.curloc;
					}
				}
			for (xc = 0;  xc < 40;  xc++)
				inv[xc] = -1;
			return (1);
			}
						/* ------ SINGLE DROP CODE ------ */
		for (xa = 5;  response[xa] != '\0';  xa++)
			item[xa - 5] = response[xa];
		item[xa - 5] = '\0';
		for (xb = 0;  xb != maxobj + 1;  xb++) {
			for (sc = 1;  sc < 5;  sc++) {
				if (strnicmp(item, obj[xb].syn[sc], strlen(obj[xb].syn[sc])) == 0) {
					for (xc = 0;  xc < 40;  xc++) {
						if (inv[xc] == xb) {
							inv[xc] = -1;
							printf("You drop %s.\n", obj[xb].small);
							a = 1;
							obj[xb].curloc = pl.curloc;
							break;
							}
						}
					}
				}
			}
		if (a != 1) {
			printf("You don't have that!\n");
			return (1);
			}
        /* Resort the inventory array so no blanks are in between items */
		xa = 0;
		i = 0;
		for (xc = 0;  xc < 40;  xc++)
			if (inv[xc] != -1) {
				invbk[i] = inv[xc];
				i++;
				}
		for (xc = 0;  xc < 40;  xc++)
			inv[xc] = -1;
		for (xc = 0;  xc < 40;  xc++)
			if (invbk[xc] != -1) {
				inv[xa] = invbk[xc];
				xa++;
				}
		for (xc = 0;  xc < 40;  xc++)
			invbk[xc] = -1;
		return (1);
		}
	return (0);
	}					/* drop */

int take(void)
	{					/* take */

	char item[20];		/* Item name string (from response) */
	int i, xa, xb, xc;	/* Misc. counter variables          */
	int gt = 4;		/* # of letters in get or take      */
	int nosee = 0;		/* Used to determine if obj is      */
				/* not in current room              */

			/* ---------- GET/TAKE CODE ---------- */
	if (strnicmp("get", response, 3) == 0 && strlen(response) < 5) {
		printf("Get what?\n");
		return (1);
		}
	if (strnicmp("take", response, 4) == 0 && strlen(response) < 6) {
		printf("Take what?\n");
		return (1);
		}
	if (strnicmp("get", response, 3) == 0 || strnicmp("take", response, 4) == 0) {
		if (strnicmp("take", response, 4) == 0)
			gt = 5;
		else gt = 4;
		for (xa = gt;  response[xa] != '\0';  xa++)
			item[xa - gt] = response[xa];
		item[xa - gt] = '\0';
		for (xb = 0;  xb != maxobj + 1;  xb++) {
			for (sc = 1;  sc < 5;  sc++) {
				if (strnicmp(item, obj[xb].syn[sc], strlen(obj[xb].syn[sc])) == 0 && strnicmp(item, "null", strlen(item)) != 0) {
					if (obj[xb].curloc == pl.curloc) {
						if (strnicmp(obj[xb].syn[4], "null", 4) == 0) {
							printf("You can't take that!\n");
							return(1);
							}
						nosee = 1;
						for (xc = 0;  xc < 40;  xc++)
							if (inv[xc] == -1) {
								inv[xc] = xb;
								printf("You get %s.\n", obj[xb].small);
								obj[xb].curloc = -1;
								break;
								}
						}
					}
				}
			}
		if (nosee == 0) {
			printf("You do not see that here.\n");
			return (1);
			}
		return (1);
		}
	return (0);
	}					/* take */

int kill(void)					/* kill */
	{
	int a,b=0,c,r,f;	/* Misc. counter variables	    */
	char item[20];		/* Item name string (from response) */
	char dah[100];		/* Used in the FLEE command */
	char bah[20];		/* Used in the FLEE command */
	char dir[20];		/* Used in the FLEE command */

	// Did they type "kill"?  If not, this function returns 0.
	if (strnicmp("kill", response, 4) != 0) return (0);
	// Make sure they typed more than just "kill"
	if (strlen(response) < 6) {
		printf("Kill who?\n");
		return (1);
		}
	// Get who they are attacking
	for (a = 5;  response[a] != '\0';  a++)
		item[a - 5] = response[a];
	item[a - 5] = '\0';
	// Big loop- goes thru all NPCs, checks if NPC is in current room,
	// check if possible to attack it, sets b = 1 if guy gets attacked
	for (a = 0; a < maxnpc + 1; a++)
		if (pl.curloc == npc[a].curloc) {
			for (c = 1; c < 5; c++) {
				if (strnicmp(item, npc[a].syn[c], strlen(npc[a].syn[c])) == 0 && strnicmp(item, "null", strlen(item)) != 0) {
					if (strnicmp(npc[a].syn[4], "null", 4) == 0) {
						printf("You can't kill them!\n");
						return(1);
						}
// --------------------ACTUAL KILL CODE STARTS HERE----------------------
	b = 1;
	f = a;
KillLoop:
	pl.pos = FIGHTING;
	npc[f].pos = FIGHTING;
	do {
	tmptime = time(NULL) - starttime;
	if (tmptime % 4 == 0 && tmptime > onetime) {
		b = (tmptime - onetime) / 4;
		onetime = tmptime;
		for (a = 0; a < b; a++)
			heartbeat();
		}
	if (tmptime % 2 == 0 && tmptime > onetime) {
		b = (tmptime - onetime) / 2;
		onetime = tmptime;
		for (a = 0; a < b; a++)
			battletick();
		}
	if (q_waiting > 0) {
		printf("\n");
		qrelease();
		printf("\n");
		showprompt();
		}

	} while (!kbhit());
	input();
//	gets(response);

	if (strlen(response) > 55)
		goto ShowPrompt;
	while (isspace(response[0])) {
		for (c = 0;  response[c] != '\0';  c++)
			response[c] = response[c + 1];
		}
NoAsk:
	if (strnicmp("flee", response, 4) == 0) {
			c = 0;
			for (r = 1; r < 7; r++)
				if (way[pl.curloc][r] != 0) c = 1;
			if (c == 0) {
				printf("\a\a\aRoom %d has no exits!!!\n", pl.curloc);
				getch();
				return (0);
				}
			do {
				r = number_range(1,6);
				} while (way[pl.curloc][r] == 0);
			switch (r) {
				case 1: strcpy(dir, "to the north.\n"); break;
				case 2: strcpy(dir, "to the south.\n"); break;
				case 3: strcpy(dir, "to the west.\n"); break;
				case 4: strcpy(dir, "to the east.\n"); break;
				case 5: strcpy(dir, "up.\n"); break;
				case 6: strcpy(dir, "down.\n"); break;
				}
			printf("You flee %s", dir);
			pl.curloc = way[pl.curloc][r];
			pl.pos = STANDING;
			npc[f].pos = STANDING;
			b = 1;
		return (2);
		}
ShowPrompt:
	showprompt();
	goto KillLoop;
// ---------------------ACTUAL KILL CODE ENDS HERE-----------------------
/*printf("\a\a\aThe code has broken through the END KILL barrier!!!\n");
getch();
return (1); */
					}
				}
			}
	if (b == 0) {
		printf("You do not see them here.\n");
		return (1);
		}
	return (1);
	}                                       /* kill */

int donate(void)
	{					/* donate */

	char item[20];		/* Item name string (from response) */
	int i, xa, xb, xc;	/* Misc. counter variables          */

			/* ----------- DONATE CODE ----------- */
	if (strnicmp("donate", response, 4) == 0) {
		if (strlen(response) < 8) {
			printf("Donate what?\n");
			return (1);
			}
		if (strnicmp("donate all\0", response, 11) == 0) {
			for (xc = 0;  xc < 40;  xc++) {
				if (inv[xc] != -1) {
					xb = inv[xc];
					inv[xc] = -1;
					printf("You donate %s.\n", obj[xb].small);
					obj[xb].curloc = 2;
					}
				}
			for (xc = 0;  xc < 40;  xc++)
				inv[xc] = -1;
			return (1);
			}
						/* ------ SINGLE DONATE CODE ------ */
		for (xa = 7;  response[xa] != '\0';  xa++)
			item[xa - 7] = response[xa];
		item[xa - 7] = '\0';
		for (xb = 0;  xb != maxobj + 1;  xb++) {
			for (sc = 1;  sc < 5;  sc++) {
				if (strnicmp(item, obj[xb].syn[sc], strlen(obj[xb].syn[sc])) == 0) {
					for (xc = 0;  xc < 40;  xc++) {
						if (inv[xc] == xb) {
							inv[xc] = -1;
							printf("You donate %s.\n", obj[xb].small);
							obj[xb].curloc = 2;
							break;
							}
						}
					}
				}
			}
        /* Resort the inventory array so no blanks are in between items */
		xa = 0;
		i = 0;
		for (xc = 0;  xc < 40;  xc++)
			if (inv[xc] != -1) {
				invbk[i] = inv[xc];
				i++;
				}
		for (xc = 0;  xc < 40;  xc++)
			inv[xc] = -1;
		for (xc = 0;  xc < 40;  xc++)
			if (invbk[xc] != -1) {
				inv[xa] = invbk[xc];
				xa++;
				}
		for (xc = 0;  xc < 40;  xc++)
			invbk[xc] = -1;
		return (1);
		}
	return (0);
	}					/* donate */

int recite(void)
	{					/* recite */

	char item[20];		  /* Item name string (from response) 	*/
	int a = 0, i, xa, xb, xc; /* Misc. counter variables          	*/
	int ret = 0;	       	  /* What to return..		    	*/

	if (strnicmp("recite", response, 6) == 0) {
		if (strlen(response) < 8) {
			printf("Recite what?\n");
			return (1);
			}
						/* ------ SINGLE DROP CODE ------ */
		for (xa = 7;  response[xa] != '\0';  xa++)
			item[xa - 7] = response[xa];
		item[xa - 7] = '\0';
		for (xb = 0;  xb != maxobj + 1;  xb++) {
			for (sc = 1;  sc < 5;  sc++) {
				if (strnicmp(item, obj[xb].syn[sc], strlen(obj[xb].syn[sc])) == 0) {
					for (xc = 0;  xc < 40;  xc++) {
						if (inv[xc] == xb && obj[xb].magic != 0) {
							inv[xc] = -1;
							printf("You recite %s which dissolves.\n", obj[xb].small);
							a = 1;
							obj[xb].curloc = 0;
							switch (obj[xb].magic) {
							case (1):
								{
								/* Scroll of Recall */
								pl.curloc = 1;
								ret = 2;
								break;
								}
								}
							break;
							}
						}
					}
				}
			}
		if (a != 1) {
			printf("You can't recite that!\n");
			return (1);
			}
	/* Resort the inventory array so no blanks are in between items */
		xa = 0;
		i = 0;
		for (xc = 0;  xc < 40;  xc++)
			if (inv[xc] != -1) {
				invbk[i] = inv[xc];
				i++;
				}
		for (xc = 0;  xc < 40;  xc++)
			inv[xc] = -1;
		for (xc = 0;  xc < 40;  xc++)
			if (invbk[xc] != -1) {
				inv[xa] = invbk[xc];
				xa++;
				}
		for (xc = 0;  xc < 40;  xc++)
			invbk[xc] = -1;
		return (ret);
		}
	return (0);
	}					/* recite */

void cls(void)
	{					/* cls */

	union REGS r;

	r.h.ah = 6;
	r.h.al = 0;
	r.h.ch = 0;
	r.h.cl = 0;
	r.h.dh = 24;
	r.h.dl = 79;
	r.h.bh = 7;
	int86(0x10, &r, &r);

	r.h.ah = 2;
	r.h.dl = 0;
	r.h.dh = 0;
	r.h.bh = 0;
	int86(0x10, &r, &r);

	}					/* cls */

wield(void)
	{					/* equip */

	char item[20];		/* Item name string (from response) */
	int a, i, xa, xb, xc;	/* Misc. counter variables      */

                        /* ----------- EQUIP CODE ----------- */
	if (strnicmp("wield", response, 5) == 0) {
		if (strlen(response) < 7) {
			printf("Wield what?\n");
			return (1);
			}
						/* ------ WIELD CODE ------ */
		if (equipinv[16] != -1) {
			printf("You're already wielding something!\n");
			return (1);
			}

		for (xa = 6;  response[xa] != '\0';  xa++)
			item[xa - 6] = response[xa];
		item[xa - 6] = '\0';
		for (xb = 0;  xb != maxobj + 1;  xb++) {
			for (sc = 1;  sc < 5;  sc++) {
				if (strnicmp(item, obj[xb].syn[sc],
					strlen(obj[xb].syn[sc])) == 0 && obj[xb].worn == 16
					&& equipinv[16] == -1) {
					for (xc = 0;  xc < 40;  xc++) {
						if (inv[xc] == xb) {
							inv[xc] = -1;
							printf("You wield %s.\n", obj[xb].small);
							pl.hitroll = pl.hitroll + obj[xb].hitroll;
							pl.damroll = pl.damroll + obj[xb].damroll;
							a = 1;
							equipinv[16] = xb;
							obj[xb].curloc = 0;
							break;
							}
						}
					}
				}
			}
		if (a != 1) {
			a = 0;
			printf("You can't wield that!\n");
			return (1);
			}
        /* Resort the inventory array so no blanks are in between items */
		xa = 0;
		i = 0;
		for (xc = 0;  xc < 40;  xc++)
			if (inv[xc] != -1) {
				invbk[i] = inv[xc];
				i++;
				}
		for (xc = 0;  xc < 40;  xc++)
			inv[xc] = -1;
		for (xc = 0;  xc < 40;  xc++)
			if (invbk[xc] != -1) {
				inv[xa] = invbk[xc];
				xa++;
				}
		for (xc = 0;  xc < 40;  xc++)
			invbk[xc] = -1;
		return (1);
		}
	return (0);

	}					/* equip */

void equ(void)
	{					/* equ */

	int xa, i = 0;

	printf("You are using:\n");
	for (xa = 0;  xa < 18;  xa++) {
		if (equipinv[xa] != -1) {
			printf("%s %s\n", bpos[xa], obj[equipinv[xa]].small);
			i = 1;
			}
		}
	if (i != 1)
		printf(" Nothing.\n");
	else i = 0;

	}					/* equ */

int rem(void)
	{					/* remove */

	char item[20];		/* Item name string (from response) */
	int i, xa, xb, xc;	/* Misc. counter variables      */
	int nosee = 0;		/* Used to determine if obj is  */
				/* not in current room          */

                        /* ---------- REMOVE CODE ---------- */
	if (strnicmp("remove", response, 6) == 0) {
		if (strlen(response) < 8) {
			printf("Remove what?\n");
			return (1);
			}
		for (xa = 7;  response[xa] != '\0';  xa++)
			item[xa - 7] = response[xa];
		item[xa - 7] = '\0';
		for (xb = 0;  xb != maxobj + 1;  xb++) {
			if (obj[xb].worn == 0)
				continue;
			for (sc = 1;  sc < 5;  sc++) {
				if (strnicmp(item, obj[xb].syn[sc], strlen(obj[xb].syn[sc])) == 0) {
					for (i = 1;  i < 20;  i++) {
						if (equipinv[i] == xb) {
							nosee = 1;
							for (xc = 0;  xc < 40;  xc++)
								if (inv[xc] == -1) {
									inv[xc] = xb;
									printf("You stop using %s.\n", obj[xb].small);
									pl.ac = pl.ac + obj[xb].ac;
									if (obj[xb].worn == 16) {
										pl.hitroll = pl.hitroll - obj[xb].hitroll;
										pl.damroll = pl.damroll - obj[xb].damroll;
										}
									else pl.bonus = pl.bonus - obj[xb].damroll;
									equipinv[i] = -1;
									break;
									}
							}
						}
					}
				}
			}
		if (nosee == 0) {
			printf("You're not using it.\n");
			return (1);
			}
		return (1);
		}
	return (0);

	}					/* rem */

int wear(void)
	{					/* wear */

	char item[20];		/* Item name string (from response) */
	int a = 0, ne = 0, i, xa, xb, xc;	/* Misc. counter variables */

	if (strnicmp("wear", response, 4) == 0) {
		if (strlen(response) < 6) {
			printf("Wear what?\n");
			return (1);
			}
						/* ------ WEAR CODE ------ */
		for (xa = 5;  response[xa] != '\0';  xa++)
			item[xa - 5] = response[xa];
		item[xa - 5] = '\0';

		for (xb = 0;  xb != maxobj + 1;  xb++) {
			for (sc = 1;  sc < 5;  sc++) {
				if (strnicmp(item, obj[xb].syn[sc], strlen(obj[xb].syn[sc])) == 0) {
					for (xc = 0;  xc < 40;  xc++) {
						if (inv[xc] == xb) {
							for (i = 1;  i < 16;  i++) {
								if (obj[xb].worn == i && equipinv[i + 1] == -1) {
									if (equipinv[i] != -1)
										ne = 1;
									}
								if (obj[xb].worn == i && (equipinv[i] == -1 || ne == 1)) {
									inv[xc] = -1;
									printf("You wear %s.\n", obj[xb].small);
									pl.ac = pl.ac - obj[xb].ac;
									pl.bonus = pl.bonus + obj[xb].damroll;
									a = 1;
									if (ne == 1) {
										equipinv[i + 1] = xb;
										ne = 0;
										goto NoEquipinv;
										}
									equipinv[i] = xb;
NoEquipinv:
									obj[xb].curloc = 0;
									break;
									}
								}
							}
						}
					}
				}
			}
		if (a != 1) {
			printf("You can't wear that!\n");
			return (1);
			}


	/* Resort the inventory array so no blanks are in between items */
		xa = 0;
		i = 0;
		for (xc = 0;  xc < 40;  xc++)
			if (inv[xc] != -1) {
				invbk[i] = inv[xc];
				i++;
				}
		for (xc = 0;  xc < 40;  xc++)
			inv[xc] = -1;
		for (xc = 0;  xc < 40;  xc++)
			if (invbk[xc] != -1) {
				inv[xa] = invbk[xc];
				xa++;
				}
		for (xc = 0;  xc < 40;  xc++)
			invbk[xc] = -1;
		return (1);
		}
	return (0);

	}					/* wear */

void locate(int x, int y)
	{					/* locate */

	union REGS r;

	r.h.ah = 2;
	r.h.dl = y;
	r.h.dh = x;
	r.h.bh = 0;
	int86(0x10, &r, &r);

	}					/* locate */

void longhelp(void)
	{					/* longhelp */

	FILE *fphelp;
	int a = 0, c = 0;
	char show[81];
	char item[25];		/* Item name string (from response) */

	if ((fphelp = fopen("help.dat", "r")) == NULL) {
		printf("\n\aError, cannot open HELP.DAT help data file.\n\n");
		return;
		}
	for (a = 5;  response[a] != '\0';  a++)
		item[a - 5] = response[a];
	item[a - 5] = '\0';

	do	{
		fgets(show, 80, fphelp);
		if (show[0] != '~') {
			if (strnicmp(item, show, strlen(item)) == 0) {
				c = 1;
				}
			if (c == 1)
				printf("%s", show);
			}
		if (show[0] == '~' && c == 1)
			break;

		}
	while (show[0] != '_');

	if (c != 1)
		printf("Help could not be found for that topic.\n");

	fclose(fphelp);

	}					/* longhelp */

int hold(void)
	{					/* hold */

	char item[20];		/* Item name string (from response) */
	int a, i, xa, xb, xc;	/* Misc. counter variables      */

			/* ----------- EQUIP CODE ----------- */
	if (strnicmp("hold", response, 4) == 0) {
		if (strlen(response) < 6) {
			printf("Hold what?\n");
			return (1);
			}
						/* ------ WIELD CODE ------ */
		if (equipinv[17] != -1) {
			printf("You're already holding something!\n");
			return (1);
			}

		for (xa = 5;  response[xa] != '\0';  xa++)
			item[xa - 5] = response[xa];
		item[xa - 5] = '\0';
		for (xb = 0;  xb != maxobj + 1;  xb++) {
			for (sc = 1;  sc < 5;  sc++) {
				if (strnicmp(item, obj[xb].syn[sc],
					strlen(obj[xb].syn[sc])) == 0 && obj[xb].worn == 17
					&& equipinv[17] == -1) {
					for (xc = 0;  xc < 40;  xc++) {
						if (inv[xc] == xb) {
							inv[xc] = -1;
							printf("You hold %s.\n", obj[xb].small);
							a = 1;
							equipinv[17] = xb;
							obj[xb].curloc = 0;
							break;
							}
						}
					}
				}
			}
		if (a != 1) {
			a = 0;
			printf("You can't hold that!\n");
			return (1);
			}
	/* Resort the inventory array so no blanks are in between items */
		xa = 0;
		i = 0;
		for (xc = 0;  xc < 40;  xc++)
			if (inv[xc] != -1) {
				invbk[i] = inv[xc];
				i++;
				}
		for (xc = 0;  xc < 40;  xc++)
			inv[xc] = -1;
		for (xc = 0;  xc < 40;  xc++)
			if (invbk[xc] != -1) {
				inv[xa] = invbk[xc];
				xa++;
				}
		for (xc = 0;  xc < 40;  xc++)
			invbk[xc] = -1;
		return (1);
		}
	return (0);

	}					/* hold */

void get_rc(int *row, int *col)
	{
	union REGS regs;

	regs.h.ah = 3;
	regs.h.bh = 0;		/* again, assume video page 0       */

	int86(0x10, &regs, &regs);

	*row = regs.h.dh;
	*col = regs.h.dl;
	}

int is_ansi_loaded(void)
	{
	int save_r, save_c;
	int new_r, new_c;
	int isloaded;

	get_rc(&save_r, &save_c);
	locate(15, 15);
	fputs("\x1B[0;0H", stderr);

	get_rc(&new_r, &new_c);

	if (new_r == 0 && new_c == 0)
		isloaded = TRUE;
	else
		{
		isloaded = FALSE;
		fputs("\b\b\b\b\b\b      \b\b\b\b\b\b", stderr);
		}

	locate(save_r, save_c);
	return isloaded;
	}

int score(void)
	{					/* score */

	if (strnicmp("score", response, 5) == 0) {
		printf("Your Score:\n");
		printf("You have %d(%d) hit, %d(%d) mana and %d(%d) movement points.\n",
			pl.hit, pl.maxhit, pl.mana, pl.maxmana, pl.move, pl.maxmove);
		printf("Your armor class is %d/10; your alignment is: %d\n",
			pl.ac, pl.alignment);
		printf("Your regeneration factors are:  H: 0     M: 0     V: 0\n");
		printf("You have scored %lu exp, and have %d gold coins.\n",
			pl.exp, pl.gold);
		if (pl.level < 30) {
			printf("You need %lu exp to reach your next level.\n",
				levexp[pl.level] - pl.exp);
			}
		else printf("You're already at the highest level possible!\n");
		pl.sec = (time(NULL) - starttime + pl.min);
		printf("You have been playing for %d seconds.\n",
			pl.sec);
		printf("This ranks you as %s %s (level %d)\n",
			pl.name, pl.title, pl.level);
		printf("You are %s.\n", posdesc[pl.pos]);
		return (1);
		}
	return (0);
	}					/* score */

void countrooms(void)
	{					/* countrooms */

	FILE *fproom;
	int b = 0;
	char show[81];

	if ((fproom = fopen("room.dat", "r")) == NULL) {
		printf("\n\aError, cannot open ROOM.DAT room data file.\n\n");
		exit(1);
		}

	do	{
		fgets(show, 80, fproom);
		if (show[0] == '~')
			b++;
		}
	while (show[0] != '_');

	totalrooms = b - 1;

	fclose(fproom);

	}					/* countrooms */

void loadplayer(void)
	{					/* loadplayer */

	FILE *fppfile;
	int a;
	char nameclone[20];
	char titleclone[70];

	if ((fppfile = fopen("player.dat", "r")) == NULL) {
		cls();
AskName:
		printf("Ah, I see we have a new player!  What is your name? ");
		gets(pl.name);
		if (strlen(pl.name) > 15) {
			printf("Sorry, but your name must be 15 characters or less.\n");
			goto AskName;
			}
		pl.curloc = 1;
		pl.hit = 27;
		pl.maxhit = 27;
		pl.hitregen = 2;
		pl.mana = 90;
		pl.maxmana = 90;
		pl.manaregen = 2;
		pl.move = 80;
		pl.maxmove = 80;
		pl.moveregen = 2;
		pl.ac = 100;
		pl.alignment = 0;
		pl.exp = 0;
		pl.gold = 20000;
		pl.sec = 0;
		pl.pos = 0;
		pl.level = 1;
		strcpy(pl.title, levtitle[1]);
		saveplayer();
		printf("\nYour new character is all set!  If you wish to delete yourself,\n");
		printf("delete the file PLAYER.DAT.  Have fun!\n\n");
		printf("Press a key to continue...");
		getch();
		cls();
		return;
		}

	fgets(nameclone, 16, fppfile);
	fgets(titleclone, 69, fppfile);
	for (a = 0;  nameclone[a] != '\n';  a++)
		pl.name[a] = nameclone[a];
	for (a = 0;  titleclone[a] != '\n';  a++)
		pl.title[a] = titleclone[a];

	fscanf(fppfile, "%d,%d,%d,%d,%lu,%d,%d\n",
		&pl.maxhit, &pl.maxmana, &pl.maxmove, &pl.alignment,
		&pl.exp, &pl.gold, &pl.level);

	pl.curloc = 1;
	pl.hit = pl.maxhit;
	pl.mana = pl.maxmana;
	pl.move = pl.maxmove;
	pl.hitregen = 2;
	pl.manaregen = 2;
	pl.moveregen = 2;
	pl.ac = 100;
	pl.pos = 0;

	fclose(fppfile);

	}					/* loadplayer */

int saveplayer(void)
	{					/* saveplayer */

	FILE *fpplayer;

	if ((fpplayer = fopen("player.dat", "w")) == NULL) {
		printf("\n\aError, cannot open PLAYER.DAT player data file.\n\n");
		return (1);
		}

	fputs(pl.name, fpplayer);
	fprintf(fpplayer, "\n");
	fputs(pl.title, fpplayer);
	fprintf(fpplayer, "\n");
	fprintf(fpplayer, "%d,%d,%d,%d,%lu,%d,%d\n",
		pl.maxhit, pl.maxmana, pl.maxmove, pl.alignment, pl.exp, pl.gold, pl.level);
	fclose(fpplayer);
	return(0);
	}					/* saveplayer */

int dice(int num, int sides)
	{					/* dice */
	int die = 0;
	while (num--)
		die += rand() % sides + 1;
	return (die);
	}					/* dice */

void info(void)
	{					/* info */

	union REGS r;
	char ap[3] = { "AM" };
	char day[7][10] = { "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday",
						"Friday", "Saturday" };
	char month[12][10] = { "January", "February", "March", "April", "May",
							"June", "July", "August", "September", "October",
							"November", "December" };

	r.h.ah = 0x30;
	int86(0x21, &r, &r);
	if (r.h.al < 20)
		printf("\nYou are currently running DOS version %d.%d.\n", r.h.al, r.h.ah);
	else printf("\nYou are currently running OS/2 version %d.%d.\n", r.h.al / 10, r.h.ah);

	r.h.ah = 0x19;
	int86(0x21, &r, &r);
	printf("You are currently on drive %c:.\n", r.h.al + 65);

	r.h.al = 0;
	r.h.ah = 0;
	int86(0x33, &r, &r);
	if (r.h.ah == 0xFF)
		printf("You have a mouse driver loaded.\n");
	else printf("You don't have a mouse driver loaded.\n");

	r.h.ah = 0x2C;
	int86(0x21, &r, &r);
	if (r.h.ch > 12) {
		r.h.ch = r.h.ch - 12;
		strcpy(ap, "PM");
		}
	printf("The current time is:  %d:%d:%d.%d %s\n", r.h.ch, r.h.cl, r.h.dh, r.h.dl, ap);

	r.h.ah = 0x2A;
	int86(0x21, &r, &r);
	printf("The current date is:  %s, %s %d\n", day[r.h.al], month[r.h.dh - 1], r.h.dl);

	}					/* info */

int number_range(int from, int to)
	{					/* number_range */
	int number;

	if (from > to) printf("\a");
No:
	do	{
		number = rand() % to + 1;
		}
	while (number < from || number > to);
	return (number);

	}					/* number_range */
void heartbeat(void)
	{
	char dah[100];
	char bah[20];
	char dir[20];
	int i,b=0,r,c,d = 0;

	if (heartcount == 0) randomize();

	heartcount++;
	if (soundfx) {
	sound(80);
	delay(10);
	nosound(); }

	for (i = 0; i < maxnpc + 1; i++) {
		if (npc[i].curloc == 0 || npc[i].curloc == 200)
			printf("WARNING!!  NPC #%d is in room #%d!!!  What a buttmunch.\n", i, npc[i].curloc);
		}

	for (i = 0; i < maxnpc + 1; i++) {
		if (npc[i].pos == FIGHTING) continue;
		if (npc[i].mobility == 0) continue;
		if (number_range(1,NPC_MOVE_CHANCE) == 1) {
			do {
				d = 0;
				for (c = 1; c < 7; c++)
					if (way[npc[i].curloc][c] != 0) d = 1;
				if (d == 0) {
					printf("We have a trapped NPC #%d in room #%d...\n", i, npc[i].curloc);
					printf("WARNING!!  TRAPPED!  Press enter to continue..\n");
					getch();
					continue;
					}
				do {
					r = number_range(1,6);
					} while (way[npc[i].curloc][r] == 0 || way[npc[i].curloc][r] == 200);
				if (pl.curloc == npc[i].curloc) {
				switch (r) {
					case 1: strcpy(dir, "to the north.\n"); break;
					case 2: strcpy(dir, "to the south.\n"); break;
					case 3: strcpy(dir, "to the west.\n"); break;
					case 4: strcpy(dir, "to the east.\n"); break;
					case 5: strcpy(dir, "up.\n"); break;
					case 6: strcpy(dir, "down.\n"); break;
				}
					strcpy(dah, "The ");
					strcat(dah, npc[i].syn[1]);
					strcat(dah, " has departed ");
					strcat(dah, dir);
					qprintf(dah);
					}
				npc[i].curloc = way[npc[i].curloc][r];
				if (pl.curloc == npc[i].curloc) {
				switch (r) {
					case 2: strcpy(dir, "the north.\n"); break;
					case 1: strcpy(dir, "the south.\n"); break;
					case 4: strcpy(dir, "the west.\n"); break;
					case 3: strcpy(dir, "the east.\n"); break;
					case 6: strcpy(dir, "above.\n"); break;
					case 5: strcpy(dir, "below.\n"); break;
				}
					strcpy(dah, "The ");
					strcat(dah, npc[i].syn[1]);
					strcat(dah, " has arrived from ");
					strcat(dah, dir);
					qprintf(dah);
					}
				b = 1;
			} while (b == 0);
		}
	}
	if (pl.hit < pl.maxhit) {
		pl.hit+=pl.hitregen;
		if (pl.hit > pl.maxhit) pl.hit = pl.maxhit;
		}
	if (pl.mana < pl.maxmana) {
		pl.mana+=pl.manaregen;
		if (pl.mana > pl.maxmana) pl.mana = pl.maxmana;
		}
	if (pl.move < pl.maxmove) {
		pl.move+=pl.moveregen;
		if (pl.move > pl.maxmove) pl.move = pl.maxmove;
		}
	if (pl.hit > 0 && (pl.pos == KO || pl.pos == MW || pl.pos == DEAD)) {
		qprintf("You have recovered from your critical wounds.\n");
		pl.pos = STANDING;
		}
	if (pl.hit == 0) {
		qprintf("You are unconscious!\n");
		pl.pos = KO;
		}
	if (pl.hit < 0 && pl.hit > -9) {
		qprintf("You are mortally wounded!\n");
		pl.pos = MW;
		}
	if (pl.hit < -8) {
		qprintf("You are DEAD!\n");
		pl.pos = DEAD;
		}
	}

void input(void) {
char ch;
int count=0,b,a;

response[0] = '\0';
do {
	do {
		tmptime = time(NULL) - starttime;
		if (tmptime % 4 == 0 && tmptime > onetime) {
			b = (tmptime - onetime) / 4;
			onetime = tmptime;
			for (a = 0; a < b; a++)
				heartbeat();
				}
		if (q_waiting > 0) {
			printf("\n");
			qrelease();
			printf("\n");
			showprompt();
			printf(response);
			}
	} while (!kbhit());

	ch = getch();
	if (ch != 13 && ch != 8 && ch < 32) continue;
	if (count < 1 && ch == 8) continue;
	printf("%c", ch);

	switch (ch) {
		case ('\b'): {
			printf(" \b");
			count--;
			response[count] = '\0';
			break;
			}
		case (13): {
			response[count] = '\0';
			printf("\n");
			return;
			}
		default: {
			response[count] = ch;
			count++;
			break;
			}
		}
	} while (1);
}

void showprompt(void) {
	sprintf(prompt, "<%dhp %dm %dmv leader: %.0f%> ",pl.hit, pl.mana, pl.move, (float) ((float) pl.hit / (float) pl.maxhit) * 100);
	printf(prompt);
}

void battletick(void) {
	sound(500);
	delay(30);
//	printf("Battle tick!\n");
	nosound();
}